<script setup lang="ts">
  import { ClientApiError } from '@shopware-pwa/types';
  import { required, email } from '@vuelidate/validators';
  import { useVuelidate } from '@vuelidate/core';
  import { getErrorMessages } from '~/helpers/errors';

  const props = defineProps<{
    controller: ReturnType<typeof useModal>;
  }>();

  const emits = defineEmits<{
    (e: 'forgot-password'): void;
    (e: 'success'): void;
  }>();

  const { t } = useI18n();
  const { isLoggedIn, login } = useUser();
  const { mergeWishlistProducts } = useWishlist();
  const { createToast } = useToasts();

  const loginErrorMsg = ref<string>();
  const isLoading = ref<boolean>();

  const state = reactive({
    email: '',
    password: '',
  });

  const rules = {
    email: {
      required,
      email,
    },
    password: {
      required,
    },
  };

  const $v = useVuelidate(rules, state);

  const onCloseModal = () => {
    props.controller.close();
  };

  const onChange = () => {
    loginErrorMsg.value = '';
  };

  const invokeLogin = async (e: Event): Promise<void> => {
    e.preventDefault();
    $v.value.$touch();
    const valid = await $v.value.$validate();
    if (valid) {
      try {
        isLoading.value = true;
        await login({
          username: state.email,
          password: state.password,
        });
        emits('success');
        createToast({
          content: t('account.messages.loggedInSuccess'),
          variant: 'success',
        });
        onCloseModal();
        mergeWishlistProducts();
      } catch (e) {
        loginErrorMsg.value = getErrorMessages(e as ClientApiError) as string;
      } finally {
        isLoading.value = false;
      }
    }
  };
</script>

<template>
  <SwModal :modal-title="$t('account.logIn')" :controller="controller">
    <template #body>
      <div class="flex">
        <div v-if="!isLoggedIn" class="w-sm">
          <div class="flex flex-col space-y-6 pb-3">
            <SwTextField
              id="email"
              v-model="state.email"
              :placeholder="$t('loginForm.emailPlaceholder')"
              name="email"
              type="email"
              size="large"
              :errors="$v.email.$errors"
              :label="$t('email')"
              @change="onChange"
              @blur="$v.email.$touch"
            />
            <SwTextField
              id="password"
              v-model="state.password"
              :placeholder="$t('loginForm.enterPassword')"
              name="password"
              type="password"
              size="large"
              :errors="$v.password.$errors"
              :label="$t('password')"
              @change="onChange"
              @blur="$v.password.$touch"
            />
          </div>

          <SwLink class="text-sm/6 font-medium" @click="emits('forgot-password')">
            {{ $t('forgotPassword') }}
          </SwLink>
          <slot name="error">
            <SwBanner v-if="loginErrorMsg" class="mt-2" variant="error" :show-close-btn="false">
              {{ loginErrorMsg }}
            </SwBanner>
          </slot>
        </div>
      </div>
    </template>
    <template #footer>
      <SwButton size="large" variant="action" @click="onCloseModal">
        {{ $t('cancel') }}
      </SwButton>
      <SwButton size="large" type="submit" :loading="isLoading" @click="invokeLogin">
        {{ $t('account.logIn') }}
      </SwButton>
    </template>
  </SwModal>
</template>
